package com.zipcodewilmington.looplabs;

import java.util.Arrays;

/**
 * Created by leon on 1/28/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class StringDuplicateDeleter extends DuplicateDeleter<String> {
    public StringDuplicateDeleter(String[] intArray) {
        super(intArray);
    }

    @Override
    public String[] removeDuplicates(int maxNumberOfDuplications) {
        Integer[] dupes = countDuplicates();
        String[] noDupes = new String[this.array.length];
        int count = 0;

        for(int i = 0; i < dupes.length; i++){
            if(dupes[i] < maxNumberOfDuplications){
                noDupes[count] = this.array[i];
                count++;
            }
        }

        return Arrays.copyOfRange(noDupes, 0, count);
    }

    @Override
    public String[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        Integer[] dupes = countDuplicates();
        String[] noDupes = new String[this.array.length];
        int count = 0;

        for(int i = 0; i < dupes.length; i++){
            if(dupes[i] != exactNumberOfDuplications){
                noDupes[count] = this.array[i];
                count++;
            }
        }

        return Arrays.copyOfRange(noDupes, 0, count);
    }

    public Integer[] countDuplicates(){
        Integer[] dupes = new Integer[this.array.length];
        Arrays.fill(dupes, 0);

        for(int i = 0; i < this.array.length; i++){
            for(int j = 0; j < this.array.length; j++){
                if(this.array[i].equals(this.array[j])){
                    dupes[i]++;
                }
            }
        }

        return dupes;
    }
}
